
/*
	File:		CompressionDialogs.r

	Contains:	Compression Dialogs  Resources

	Written by:	Mark Krueger

	Copyright:	 1991 by Apple Computer, Inc., all rights reserved.

    This file is used in these builds: Warhol

	Change History (most recent first):

		 <8>	 3/28/91	SMC		Fixed spelling error.
		 <7>	 3/26/91	SMC		First shot at motion decompression dialog.
		 <6>	 3/21/91	MK		fix slider file finding
		 <5>	 2/24/91	MK		fix low memory bugs
		 <4>	 2/12/91	MK		clean it up
		 <3>	  2/9/91	MK		add wizzy slider
		 <2>	  2/9/91	MK		add str# for menu names
		 <1>	  2/9/91	MK		first checked in

	To Do:
*/


#include	"types.r"


resource 'DITL' (200, "Compression Settings") {
	{	/* array DITLarray: 11 elements */
		/* [1] */
		{180, 174, 202, 259},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{210, 174, 232, 259},
		Button {
			enabled,
			"Cancel"
		},
		/* [3] */
		{36, 100, 54, 282},
		UserItem {
			enabled
		},
		/* [4] */
		{126, 12, 142, 282},
		UserItem {
			enabled
		},
		/* [5] */
		{72, 100, 90, 282},
		UserItem {
			enabled
		},
		/* [6] */
		{36, 12, 53, 85},
		StaticText {
			disabled,
			"Method :"
		},
		/* [7] */
		{108, 122, 125, 172 },
		StaticText {
			disabled,
			"Quality"
		},
		/* [8] */
		{144, 12, 161, 46},
		StaticText {
			disabled,
			"Low"
		},
		/* [9] */
		{144, 248, 161, 280},
		StaticText {
			enabled,
			"High"
		},
		/* [10] */
		{72, 12, 90, 96},
		StaticText {
			disabled,
			"Colorspace :"
		},
		/* [11] */
		{0, 72, 15, 228},
		StaticText {
			disabled,
			"Compression Settings"
		}
	}
};

resource 'DLOG' (200, "Compression Settings") {
	{65, 53, 301, 347},
	dBoxProc,
	visible,
	goAway,
	0x0,
	200,
	""
};


resource 'DITL' (201, "MCompression Settings", purgeable) {
	{	/* array DITLarray: 19 elements */
		/* [1] */
		{310, 174, 332, 259},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{344, 174, 366, 259},
		Button {
			enabled,
			"Cancel"
		},
		/* [3] */
		{36, 100, 54, 282},
		UserItem {
			enabled
		},
		/* [4] */
		{126, 12, 142, 282},
		UserItem {
			enabled
		},
		/* [5] */
		{72, 100, 90, 282},
		UserItem {
			enabled
		},
		/* [6] */
		{36, 12, 53, 85},
		StaticText {
			disabled,
			"Method :"
		},
		/* [7] */
		{108, 103, 125, 202},
		StaticText {
			disabled,
			"Spatial Quality"
		},
		/* [8] */
		{144, 17, 161, 51},
		StaticText {
			disabled,
			"Low"
		},
		/* [9] */
		{144, 244, 161, 276},
		StaticText {
			enabled,
			"High"
		},
		/* [10] */
		{72, 12, 90, 96},
		StaticText {
			disabled,
			"Colorspace :"
		},
		/* [11] */
		{3, 47, 20, 242},
		StaticText {
			disabled,
			"Motion Compression Settings"
		},
		/* [12] */
		{172, 84, 189, 215},
		CheckBox {
			enabled,
			"Temporal Quality"
		},
		/* [13] */
		{190, 12, 206, 282},
		UserItem {
			enabled
		},
		/* [14] */
		{208, 17, 225, 51},
		StaticText {
			disabled,
			"Low"
		},
		/* [15] */
		{208, 244, 225, 276},
		StaticText {
			enabled,
			"High"
		},
		/* [16] */
		{232, 54, 249, 165},
		StaticText {
			disabled,
			"Key Frame Rate:"
		},
		/* [17] */
		{232, 170, 248, 230},
		EditText {
			enabled,
			""
		},
		/* [18] */
		{262, 51, 279, 165},
		StaticText {
			disabled,
			"Max Frame Rate:"
		},
		/* [19] */
		{262, 170, 278, 230},
		EditText {
			enabled,
			""
		}
	}
};


resource 'DLOG' (201, "MCompression Settings", purgeable) {
	{64, 52, 444, 346},
	dBoxProc,
	visible,
	goAway,
	0x0,
	201,
	""
};



resource 'STR#' (200, "Menu Names") {
	{
		"Color",
		"GreyScale",
		"Black and White",
		"4 Greys",
		"16 Greys",
		"256 Greys",
		"2 Colors",
		"4 Colors",
		"16 Colors",
		"256 Colors",
		"Thousands of Colors",
		"Millions of Colors Packed",
		"Millions of Colors"
	}
};



type 'CDEF' {
	hex string;
};


resource 'CDEF' (200,  "Marks Wizzy Slider", sysheap,preload,locked) {

$$resource($$Shell("warholObjects")"MarksWizzySlider", 'CDEF', 200);

};

